import { jsx as d, jsxs as M } from "react/jsx-runtime";
import U, { useRef as k, useEffect as v, useCallback as j, useState as I, useMemo as F, useId as O, useReducer as X, useLayoutEffect as V } from "react";
import l from "clsx";
const R = "av-text-input", ie = "av-text-input-simple", q = "av-text-input-wrapper", A = "av-text-input-helper-text";
function z() {
  const e = k(!1);
  return v(() => (e.current = !0, () => {
    e.current = !1;
  }), []), j(() => e.current, []);
}
const H = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function W(e) {
  const n = z(), t = k(0), r = k(null), [o, a] = I(H), c = F(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((s) => {
    const u = s[0];
    u && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      r.current && n() && a(u.contentRect);
    }));
  }), [n]);
  return v(() => (r.current && (c == null || c.observe(r.current, e)), () => {
    c == null || c.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [c, e]), [r, o];
}
function G(e) {
  const n = O();
  if (!e)
    return n;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${n}`;
  if (typeof e == "object") {
    const { id: t, prefix: r = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${r}${t}` : `${r}${n}`;
  }
}
const _ = "SET_ANNOUNCEMENT", C = "CLEAR_ANNOUNCEMENT", J = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, K = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case _:
      return {
        ...e,
        announcement: n.payload
      };
    case C:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, Q = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: C
  }), typeof e == "function" && e();
}, E = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: r,
  dispatch: o
}) => {
  (t == null ? void 0 : t.current) !== null && clearTimeout(t.current), e !== null && o({
    type: _,
    payload: e
  }), n && (t.current = setTimeout(
    () => Q({
      onAnnouncementClear: r,
      dispatch: o
    }),
    n
  ));
}, Y = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: a,
  dispatch: c
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(E, t, {
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: a,
    dispatch: c
  }) : E({
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: a,
    dispatch: c
  });
};
function Z({
  children: e,
  className: n,
  politeness: t,
  role: r = null,
  announcementDelay: o,
  clearAnnouncementDelay: a,
  onAnnouncementClear: c,
  visible: s,
  ...u
}) {
  const f = k(), y = k(), [h, g] = X(K, {
    announcement: null
  });
  let p = t;
  typeof p > "u" && (p = r ? J[r] : "assertive"), v(() => {
    Y({
      announcementTimeoutRef: f,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: a,
      clearAnnouncementTimeoutRef: y,
      onAnnouncementClear: c,
      dispatch: g
    });
  }, [
    e,
    o,
    a,
    c
  ]);
  const i = l(n, {
    "sr-only": !s
  });
  return /* @__PURE__ */ d(
    "div",
    {
      "aria-live": p,
      ...r && { role: r },
      className: i,
      ...u,
      children: h.announcement
    }
  );
}
const B = (e) => {
  let n = "";
  if (typeof e == "number" || typeof e == "string")
    n = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), n = t.join(" ");
  }
  return n;
};
/*!
  @versini/ui-private v1.4.13
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.13",
    buildTime: "09/24/2024 07:45 PM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ee = ({
  mode: e
}) => l({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), te = ({
  focusMode: e
}) => l("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), ne = ({
  noBorder: e,
  error: n
}) => l("border-2", {
  "border-border-dark": !e && !n,
  "focus:border-border-dark": !e && n,
  "border-border-error-dark": !e && n,
  "border-transparent": e
}), re = ({
  disabled: e,
  raw: n,
  error: t,
  mode: r
}) => {
  if (n)
    return "";
  if (e)
    return l("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return l("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (t)
    return l("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "text-copy-lighter dark:text-copy-error-dark": r === "alt-system"
    });
}, oe = ({
  error: e,
  raw: n,
  mode: t,
  disabled: r
}) => {
  if (n)
    return "";
  if (r)
    return l(
      A,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return l(A, "absolute px-2 font-medium", {
      "text-copy-lighter": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-lighter": t === "system",
      "text-copy-lighter dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return l(A, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": t === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": t === "alt-system"
    });
}, ce = ({
  className: e,
  inputClassName: n,
  raw: t,
  disabled: r,
  noBorder: o,
  error: a,
  spacing: c,
  mode: s,
  focusMode: u
}) => {
  const f = t ? e : l(
    "relative flex w-full flex-col justify-center",
    q,
    e,
    B(c)
  ), y = t ? l(n) : l(
    R,
    n,
    "h-12 rounded-md px-4 text-base",
    ee({ mode: s }),
    te({ focusMode: u }),
    ne({ noBorder: o, error: a }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), h = t ? void 0 : "sr-only", g = re({
    disabled: r,
    raw: t,
    error: a,
    mode: s
  }), p = oe({
    error: a,
    raw: t,
    mode: s,
    disabled: r
  });
  return {
    wrapper: f,
    input: y,
    accessibleLabel: h,
    visibleLabel: g,
    helperText: p,
    rightElement: t ? void 0 : "absolute right-3"
  };
}, ae = U.forwardRef(
  ({
    id: e,
    name: n,
    label: t,
    error: r = !1,
    raw: o = !1,
    className: a,
    inputClassName: c,
    mode: s = "system",
    focusMode: u = "system",
    disabled: f = !1,
    noBorder: y = !1,
    labelId: h,
    labelHidden: g = !1,
    type: p = "text",
    helperText: i = "",
    rightElement: T,
    spacing: N,
    ...$
  }, S) => {
    const [L, b] = W(), [P, D] = I(0), x = G({ id: e, prefix: `${R}-` }), w = `${n} error, ${i}`, m = ce({
      className: a,
      inputClassName: c,
      error: r,
      raw: o,
      focusMode: u,
      disabled: f,
      noBorder: y,
      spacing: N,
      mode: s
    });
    return V(() => {
      b && b.width && D(b.width + 18 + 10);
    }, [b]), /* @__PURE__ */ M("div", { className: m.wrapper, children: [
      /* @__PURE__ */ d(
        "label",
        {
          htmlFor: x,
          id: h,
          className: m.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ d(
        "input",
        {
          ref: S,
          id: x,
          name: n,
          type: p,
          disabled: f,
          placeholder: o ? void 0 : " ",
          className: m.input,
          ...i && { "aria-describedby": `${x}-helper` },
          ...r && { "aria-invalid": "true" },
          ...T && !o && { style: { paddingRight: P } },
          ...$
        }
      ),
      !o && !g && /* @__PURE__ */ d(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: x,
          className: m.visibleLabel,
          children: t
        }
      ),
      i && /* @__PURE__ */ d(
        "div",
        {
          id: `${x}-helper`,
          className: m.helperText,
          children: i
        }
      ),
      T && /* @__PURE__ */ d(
        "div",
        {
          ref: L,
          className: m.rightElement,
          children: T
        }
      ),
      r && i && /* @__PURE__ */ d(Z, { politeness: "polite", clearAnnouncementDelay: 500, children: w })
    ] });
  }
);
ae.displayName = "TextInput";
export {
  R as TEXT_INPUT_CLASSNAME,
  A as TEXT_INPUT_HELPER_TEXT_CLASSNAME,
  ie as TEXT_INPUT_SIMPLE_CLASSNAME,
  q as TEXT_INPUT_WRAPPER_CLASSNAME,
  ae as TextInput,
  Z as j
};
